=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2007-07-03 04:29:14 +0000
+++ bzrlib/smart/repository.py	2007-07-03 04:55:45 +0000
@@ -16,6 +16,7 @@
 
 """Server-side repository related request implmentations."""
 
+import os
 import sys
 import tempfile
 import tarfile
@@ -223,7 +224,8 @@
             temp.close()
 
     def _tarball_of_dir(self, dirname, compression, ofile):
-        tarball = tarfile.open(fileobj=ofile, name=ofile.name,
+        filename = os.path.basename(ofile.name)
+        tarball = tarfile.open(fileobj=ofile, name=filename,
             mode='w|' + compression)
         try:
             # The tarball module only accepts ascii names, and (i guess)

